//+------------------------------------------------------------------+
//|                                              GannSwingsVIII.mq5  |
//|                                          Copyright  2005, Rosh  |
//|                                       http://www.metaquotes.net  |
//+------------------------------------------------------------------+
//---  
#property copyright "Copyright  2005, Rosh"
//---    
#property link "http://www.metaquotes.net"
//---   
#property version   "1.10"
//---     
#property indicator_chart_window
//---        
#property indicator_buffers 6
//---    
#property indicator_plots   5
//+-----------------------------------------------+
//|            |
//+-----------------------------------------------+
//---     
#property indicator_type1   DRAW_SECTION
//---       Gold 
#property indicator_color1 clrGold
//---   -  
#property indicator_style1  STYLE_SOLID
//---     2
#property indicator_width1  2
//---   
#property indicator_label1  "BinaryWave"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_ARROW
//---       Blue 
#property indicator_color2  clrBlue
//---   2 - -
#property indicator_style2  STYLE_DASHDOTDOT
//---    2  2
#property indicator_width2  2
//---    
#property indicator_label2  "Upper"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   3   
#property indicator_type3   DRAW_ARROW
//---        MediumVioletRed
#property indicator_color3  clrMediumVioletRed
//---   3 - -
#property indicator_style3  STYLE_DASHDOTDOT
//---    3  2
#property indicator_width3  2
//---    
#property indicator_label3  "Lower"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   4   
#property indicator_type4   DRAW_ARROW
//---       DeepSkyBlue
#property indicator_color4  clrDeepSkyBlue
//---   4  1
#property indicator_width4  1
//---   
#property indicator_label4  "Buy"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   5   
#property indicator_type5   DRAW_ARROW
//---       Magenta
#property indicator_color5  clrMagenta
//---   5  1
#property indicator_width5  1
//---   
#property indicator_label5  "Sell"
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Type
  {
   LITTLE=1,   // 
   MIDLE,      // 
   MAIN        // 
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Type  kind=LITTLE;            //  
input bool  MoveLastSwing=false;    //            High  Low
input int   Shift=0;                //      
//+----------------------------------------------+
//---   ,   
//---      
double SwingsBuffer[];
double HighsBuffer[];
double LowsBuffer[];
double TrendBuffer[];
double UpCloseOutSideBuffers[];
double DownCloseOutSideBuffers[];
//---
double SwingHigh,SwingLow;
int LastSwing,lowCounter,highCounter;
//---      
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//---     
   min_rates_total=2;

//---      
   SetIndexBuffer(0,SwingsBuffer,INDICATOR_DATA);
//---       Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(SwingsBuffer,true);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);

//---      
   SetIndexBuffer(1,HighsBuffer,INDICATOR_DATA);
//---       Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(HighsBuffer,true);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
//---   
   PlotIndexSetInteger(1,PLOT_ARROW,159);

//---      
   SetIndexBuffer(2,LowsBuffer,INDICATOR_DATA);
//---       Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(LowsBuffer,true);
//---   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);
//---   
   PlotIndexSetInteger(2,PLOT_ARROW,159);

//---      
   SetIndexBuffer(3,UpCloseOutSideBuffers,INDICATOR_DATA);
//---       Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(UpCloseOutSideBuffers,true);
//---   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);
//---   
   PlotIndexSetInteger(3,PLOT_ARROW,108);

//---      
   SetIndexBuffer(4,DownCloseOutSideBuffers,INDICATOR_DATA);
//---       Shift
   PlotIndexSetInteger(4,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(DownCloseOutSideBuffers,true);
//---   ,      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,0);
//---   
   PlotIndexSetInteger(4,PLOT_ARROW,108);

//---        
   SetIndexBuffer(5,TrendBuffer,INDICATOR_CALCULATIONS);
//---    ,      
   ArraySetAsSeries(TrendBuffer,true);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"GannSwingsVIII");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &Time[],
                const double &Open[],
                const double& High[],     //       
                const double& Low[],      //        
                const double &Close[],
                const long &Tick_Volume[],
                const long &Volume[],
                const int &Spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---    
   int limit,bar,maxbar;
   bool nonOutSide;
//---    ,     
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(Open,true);
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
//---
   maxbar=rates_total-min_rates_total-1;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=maxbar;
      lowCounter=0;
      highCounter=0;                                  //      
      LowsBuffer[limit]=Low[limit];
      SwingsBuffer[limit]=High[limit];
      SwingsBuffer[limit]=Low[limit];
      SwingHigh=High[limit];
      SwingLow=Low[limit];
      LastSwing=0;
      TrendBuffer[limit+1]=-1.0;
      TrendBuffer[limit]=-1.0;
     }
   else
     {
      limit=maxbar;
      lowCounter=0;
      highCounter=0;                                  //      
      LowsBuffer[limit]=Low[limit];
      SwingsBuffer[limit]=High[limit];
      SwingsBuffer[limit]=Low[limit];
      SwingHigh=High[limit];
      SwingLow=Low[limit];
      LastSwing=0;
      TrendBuffer[limit+1]=-1.0;
      TrendBuffer[limit]=-1.0;
     }
//---   
   LastSwing+=limit;
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      if(bar!=maxbar)
        {
         UpCloseOutSideBuffers[bar]=0.0;
         DownCloseOutSideBuffers[bar]=0.0;
         SwingsBuffer[bar]=0.0;
         HighsBuffer[bar]=0.0;
         LowsBuffer[bar]=0.0;
        }
      //---
      nonOutSide=!((High[bar]>High[bar+1]) && (Low[bar]<Low[bar+1]));
      if(!nonOutSide)
        {
         if(Close[bar]>Open[bar]) UpCloseOutSideBuffers[bar]=(High[bar]+Low[bar])/2.0;
         else DownCloseOutSideBuffers[bar]=(High[bar]+Low[bar])/2.0;
        }
      //---
      if(High[bar]>SwingHigh)
        {
         highCounter++;
         SwingHigh=High[bar];
         HighsBuffer[bar]=SwingHigh;
        }
      //---
      if(Low[bar]<SwingLow)
        {
         lowCounter++;
         SwingLow=Low[bar];
         LowsBuffer[bar]=SwingLow;
        }
      //---
      TrendBuffer[bar]=TrendBuffer[bar+1];//     -  
      if(TrendBuffer[bar+1]==-1.0 && lowCounter==1)// && nonOutSide) 
        {
         if(LastSwing!=maxbar) SwingsBuffer[LastSwing]=0.0; //   
         LastSwing=bar;
         SwingHigh=High[bar];
         SwingLow=Low[bar];
         highCounter=0;
         lowCounter=0;
         SwingsBuffer[bar]=Low[bar];
         HighsBuffer[bar]=SwingHigh;
        }
      else
        {
         if(TrendBuffer[bar+1]==-1.0 && highCounter==kind)
           {
            LastSwing=bar;
            SwingHigh=High[bar];
            SwingLow=Low[bar];
            TrendBuffer[bar]=+1.0;
            highCounter=0;
            lowCounter=0;
            SwingsBuffer[bar]=High[bar];
            LowsBuffer[bar]=SwingLow;
           }
         else
           {
            if(TrendBuffer[bar+1]==-1.0 && Low[bar]==SwingLow && MoveLastSwing)
              {
               SwingsBuffer[LastSwing]=0.0;
               LastSwing=bar;
               SwingsBuffer[bar]=Low[bar];
              }
           }
        }
      if(TrendBuffer[bar+1]==+1.0 && highCounter==1)// && nonOutSide) 
        {
         if(LastSwing!=maxbar) SwingsBuffer[LastSwing]=0.0; //   
         LastSwing=bar;
         SwingHigh=High[bar];
         SwingLow=Low[bar];
         highCounter=0;
         lowCounter=0;
         SwingsBuffer[bar]=High[bar];
         LowsBuffer[bar]=SwingLow;
         //  
        }
      else
        {
         if(TrendBuffer[bar+1]==+1.0 && lowCounter==kind)
           {
            LastSwing=bar;
            SwingHigh=High[bar];
            SwingLow=Low[bar];
            TrendBuffer[bar]=-1.0;
            highCounter=0;
            lowCounter=0;
            SwingsBuffer[bar]=Low[bar];
            HighsBuffer[bar]=SwingHigh;
            //  
           }
         else
           {
            if(TrendBuffer[bar+1]==1.0 && High[bar]==SwingHigh && MoveLastSwing)
              {
               SwingsBuffer[LastSwing]=0.0;
               LastSwing=bar;
               SwingsBuffer[bar]=High[bar];
              }
           }
        }
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+